<?
IncludeModuleLangFile(__FILE__);



class CItrackWebmessenger extends CItrackWebmessengerBase {

	private $_getters = array('bitrixUserId', 'userId', 'userName');
	private $_setters = array('existContacts');
		
	private $bitrixUserId = false;
	private $userId = false;
	private $userName = false;
	private $existContacts = array();
	
	public function __construct() {
		
		$this->setBitrixUserId();
		$this->setUserId();
		$this->setOnline();
	}

	public function __get($property) {
		if (in_array($property, $this->_getters)) {
			return $this->$property;
		}
		else if (method_exists($this, '_get_' . $property))
			return call_user_func(array($this, '_get_' . $property));
		else if (in_array($property, $this->_getters) OR method_exists($this, '_set_' . $property))
			throw new Exception('Property "' . $property . '" is write-only.');
		else
			throw new Exception('Property "' . $property . '" is not accessible.');
	}

	public function __set($property, $value) {
		if (in_array($property, $this->_setters)) {
			$this->$property = $value;
		}
		else if (method_exists($this, '_set_' . $property))
			call_user_func(array($this, '_set_' . $property), $value);
		else if (in_array($property, $this->_setters) OR method_exists($this, '_get_' . $property))
			throw new Exception('Property "' . $property . '" is read-only.');
		else
			throw new Exception('Property "' . $property . '" is not accessible.');
	}
		
	function NewMessNotifyAgent(){
		
		// получаем сообщения на которые нет ответа в течении 24ч
		global $DB;
		// выбрать, если нет - создать 
		$strSql = 'SELECT
						id, user_id_to
					FROM
						itrack_webmessenger_messages
					WHERE
						readed_user_id_to = "0" AND
						event_newmess_user_to = "0"
					';				
		$res = $DB->Query($strSql);
		while($arUser = $res->Fetch()){
			// собираем иды пользователей
			$arUserIds[$arUser['user_id_to']] = $arUser['user_id_to'];
			// собираем иды сообщений для апдейта
			$arMessageIds[$arUser['id']] = $arUser['id'];
		} 
	
		if(is_array($arMessageIds) && count($arMessageIds)){
			
			$arUserIds = array_keys($arUserIds);
			$arMessageIds = array_keys($arMessageIds);
			
			
			$sites = CSite::GetList(($b=""), ($o=""));
			if($site = $sites->Fetch())
				$sSite = $site['LID'];
			
			// отправляем сообщение что есть новое сообщение
			foreach($arUserIds as $iUserId){
				$arBitrixUser = self::getBitrixUser($iUserId);
				CEvent::Send("ITR_MESSENGER_NEW_MESSAGE", $sSite, array("EMAIL_TO" => $arBitrixUser['EMAIL']));
			}
			
			// обновляем сообщения что евент отправлен
			$strSql = 'UPDATE
							itrack_webmessenger_messages
						SET
							event_newmess_user_to = "1"
						WHERE
							id IN ('.implode(',',$arMessageIds).')
						';	
			$res = $DB->Query($strSql);		
		}

		
		return 'CItrackWebmessenger::NewMessNotifyAgent();';
	}
	
	private function setUserId(){
		
		global $DB;
		// выбрать, если нет - создать 
		$strSql = 'SELECT
						id
					FROM
						itrack_webmessenger_users
					WHERE
						'.(is_numeric($this->bitrixUserId)?'user':'guest').'_id = "'.$this->bitrixUserId.'"';
									
		$res = $DB->Query($strSql);
		if($arUser = $res->Fetch()){
			$this->userId = intval($arUser['id']);
		}else{
			$strSql = 'INSERT INTO itrack_webmessenger_users 
							(user_id, guest_id)
						VALUES 
							("'.(is_numeric($this->bitrixUserId)?$this->bitrixUserId:0).'","'.(is_numeric($this->bitrixUserId)?'':$this->bitrixUserId).'");
						';
			$DB->Query($strSql);	
			$this->userId = $DB->LastID();

		}
	}
	
	function getWebmessengerUsersAll($by="id", $order="asc"){
	
		if(!in_array($by, array("id", "user_id", "guest_id", "last_online")))
		{
			$by = "id";
		}

		if(!in_array($order, array("asc", "desc")))
		{
			$order = "asc";
		}
		global $DB;
		$strSql = '
			SELECT 
				u.id,
				u.user_id,
				u.guest_id,
				u.last_online,
				mess.message
			FROM 
				itrack_webmessenger_users u
			LEFT JOIN 
				(select * from itrack_webmessenger_messages order by id desc) as mess
			ON  u.id = mess.user_id_from
			WHERE mess.message != ""
			GROUP BY u.user_id
			ORDER BY u.'.$by.' '.$order.'
		';
		$arResult = array();
		$obUser = $DB->Query($strSql);
		while($arUser = $obUser->Fetch()){
			$arResult[] = $arUser;
		}
		
		return $arResult;
	}
	
	private function setOnline(){
		global $DB;
		$strSql = 'UPDATE 
					itrack_webmessenger_users
				SET
					last_online = "'.date("Y-m-d H:i:s").'"
				WHERE
					id = "'.$this->userId.'"';
		$DB->Query($strSql); 	
	}	
	
	// смена владельца
	public function changeOwner(){
		if( is_numeric($this->bitrixUserId) && array_key_exists("fixed_session_id", $_SESSION) ){
			
			global $DB;
		
			$strSql = 'SELECT
							id,
							user_id,
							guest_id
						FROM
							itrack_webmessenger_users
						WHERE
							guest_id = "'.$_SESSION["fixed_session_id"].'"';
			
			$res = $DB->Query($strSql);
			$sGuestId = '';
			if($arUser = $res->Fetch()){
				$sGuestId = intval($arUser['id']);
			}
			
			$strSql = 'SELECT
							id,
							user_id,
							guest_id
						FROM
							itrack_webmessenger_users
						WHERE
							user_id = "'.$this->bitrixUserId.'"';
			$res = $DB->Query($strSql);
			$iUserId = 0;
			if($arUser = $res->Fetch()){
				$iUserId = intval($arUser['id']);
			}
		
			/* 
				если гостевой пользователь есть, а обычного нет
				меняем ид с гостевого на обычный
			*/
			if(strlen($sGuestId) && !intval($iUserId)){
			
				$strSql = 'UPDATE 
							itrack_webmessenger_users
						SET
							user_id = "'.$this->bitrixUserId.'",
							guest_id = ""
						WHERE
							guest_id = "'.$sGuestId.'"';
				$DB->Query($strSql); 
			}
			/* 
				если есть и гостевой и обычный
				меняем во всех таблицах ид гостевого пользователя на обычный
				удаляем гостевую запись из пользователей
			*/
			else if(strlen($sGuestId) && intval($iUserId)){
				
				// обновляем свой лист
				$strSql = 'UPDATE 
							itrack_webmessenger_contactlist
						SET
							user_id = "'.$iUserId.'"
						WHERE
							user_id = "'.$sGuestId.'"';
				$DB->Query($strSql);
				
				// обновляем себя у людей в листах
				$strSql = 'UPDATE 
							itrack_webmessenger_contactlist
						SET
							user_id_list = "'.$iUserId.'"
						WHERE
							user_id_list = "'.$sGuestId.'"';
				$DB->Query($strSql); 
				
				// обновляем свои группы
				$strSql = 'UPDATE 
							itrack_webmessenger_groups
						SET
							user_id = "'.$iUserId.'"
						WHERE
							user_id = "'.$sGuestId.'"';
				$DB->Query($strSql); 
				
				// обновляем свои сообщения
				$strSql = 'UPDATE 
							itrack_webmessenger_messages
						SET
							user_id_from = "'.$iUserId.'"
						WHERE
							user_id_from = "'.$sGuestId.'"';
				$DB->Query($strSql); 
				
				// обновляем чужие сообщения сообщения
				$strSql = 'UPDATE 
							itrack_webmessenger_messages
						SET
							user_id_to = "'.$iUserId.'"
						WHERE
							user_id_to = "'.$sGuestId.'"';
				$DB->Query($strSql); 
				
				// удаляем из списка старый id пользователя
				$strSql = 'DELETE FROM 
							itrack_webmessenger_users
						WHERE
							id = "'.$sGuestId.'"';
				$DB->Query($strSql); 
			}
			
		}
	}
	
	private function _get_contactList($iUserId){
		
		global $DB;
		
		if(!intval($iUserId)) $iUserId = $this->userId;
		
		
		if(is_array($this->existContacts) && count($this->existContacts)){
			$arExIds = array_map('intval', $this->existContacts);
		}else{
			$arExIds = array(0);
		}

		// получаем список пользователей по группам
		$strSql = '
			SELECT 
				list.*,
				user.user_id bitrixId,
				user.guest_id bitrixGuestId,
				user.last_online,
				groups.id groupId,
				groups.name groupName
			FROM 
							itrack_webmessenger_contactlist list 
				LEFT JOIN	itrack_webmessenger_users user ON user.id = list.user_id_list
				JOIN	itrack_webmessenger_groups groups ON list.group_id = groups.id
			WHERE
				list.user_id = "'.$iUserId.'"
		';
		$obContactList = $DB->Query($strSql);
		$arResult = array('online'=>array(),'del'=>array(), 'newU'=>array());
		while($arContact = $obContactList->Fetch()){

			$bIsOnline = (strtotime($arContact['last_online']) > (time()-40))?true:false;
			$arResult['online'][$arContact['user_id_list']] = $bIsOnline;
		
			// если нет в листе
			if(!in_array($arContact['user_id_list'], $arExIds)){
				$arBitrixUser = $this->getBitrixUser($arContact['user_id_list']);
				$arResult['newU'][intval($arContact['user_id_list'])] = array(
																	'id'		=>	intval($arContact['user_id_list']),
																	'name'		=>	$arBitrixUser['name'],
																	'list'		=>	$arContact['groupName'],
																	'list_id'	=>	intval($arContact['groupId'])
																);								
			}
				
		}
		
		foreach($arExIds as $iId){
			if(!array_key_exists($iId, $arResult['online'])){
				$arResult['del'][] = $iId;
				unset($arResult['online'][$iId]);
				unset($arResult['newU'][$iId]);
			}
		}
		return $arResult;	
	}
	
	function getBitrixUser($iUserId){
	
		global $DB;
		$strSql = '
			SELECT 
				*
			FROM 
				itrack_webmessenger_users
			WHERE
				id = "'.intval($iUserId).'"
		';
		$arResult = array('name'=>'Гость'.$iUserId);
		$obUser = $DB->Query($strSql);
		if($arUser = $obUser->Fetch()){
			
			if(intval($arUser['user_id'])){
				$rsBitrixUser = CUser::GetByID($arUser['user_id']);
				
				$arBitrixUser = $rsBitrixUser->Fetch();
				//var_export($arBitrixUser);
				$arResult = $arBitrixUser;
				$arResult['name'] = trim($arBitrixUser['NAME'].' '.$arBitrixUser['LAST_NAME']);
				$arResult['name'] = (strlen($arResult['name']))?$arResult['name']:$arBitrixUser['LOGIN'];
			}
		}
		return $arResult;
	}
	
	function getWebmessengerUsers($arBitrixIds = array(0)){
	
		global $DB;
		$strSql = '
			SELECT 
				*
			FROM 
				itrack_webmessenger_users
			WHERE
				user_id IN ('.implode(',', $arBitrixIds).') AND
				guest_id = ""
			ORDER BY last_online DESC
		';
		$arResult = array();
		$obUser = $DB->Query($strSql);
		while($arUser = $obUser->Fetch()){
			$arResult[] = $arUser;
		}
		
		return $arResult;
	}
	
	private function setBitrixUserId(){
		if(CUser::IsAuthorized() && isset($GLOBALS["USER"]) && is_object($GLOBALS["USER"]) ){
			$this->bitrixUserId = CUser::GetID();
			$this->userName = CUser::GetFullName();
			$this->userName = (strlen($this->userName))?$this->userName:CUser::GetLogin();
		}else{
			if(array_key_exists("fixed_session_id", $_SESSION)){
				$this->bitrixUserId = $_SESSION["fixed_session_id"];
			}else{ 
				$this->bitrixUserId = false;
			}
			$this->userName = GetMessage("ITRACK_WEBMESSENGER_GOSTQ").$this->userId;
		}
	}
	
	function getSupportUserId(){
		global $DB;
		
		if(!isset($_SESSION['WEBMESSENGER_SUPPORT_USER']) || !intval($_SESSION['WEBMESSENGER_SUPPORT_USER'])){
		
			$iSupportGroup = COption::GetOptionInt('itrack.webmessenger', 'supportGroup', 1);
			
			$filter = Array("GROUPS_ID"	=> Array($iSupportGroup));
			$rsUsers = CUser::GetList(($by="personal_country"), ($order="desc"), $filter); 
			while($arUser = $rsUsers->Fetch()){
				$arIds[] = $arUser['ID'];
			}

			$arWebmUsers = $this->getWebmessengerUsers($arIds);			
			foreach($arWebmUsers as $arUser){
				$bIsOnline = (strtotime($arUser['last_online']) > (time()-40))?true:false;
				if($bIsOnline){
					$_SESSION['WEBMESSENGER_SUPPORT_USER'] = $arUser['id'];
					break;
				}
			}
			
		}
		return $_SESSION['WEBMESSENGER_SUPPORT_USER'];
	}
	
	
	function addMessage($iContactId, $sMessage){
		
		global $DB;
		
		$defaultGroup = 2;
		
		if(!intval($iContactId)){
			$iContactId = $this->getSupportUserId();
			$defaultGroup = 1;
		}
		
		
		if(!intval($iContactId)){return array('status'=>'nouser', 'toId'=> $iContactId);}
		
		// получаем контакт лист получателя
		$arRemoteContactList = $this->_get_contactList($iContactId);
		
		// добавляемся в общую группу к пользователю
		if(array_key_exists($this->userId, $arRemoteContactList['newU'])){
			// если мы у него в игноре
			if($arRemoteContactList['newU'][$this->userId]['list_id'] == 3) return array('status'=>'ignor', 'toId'=> $iContactId);
		}else{
			$this->addUserToGroup($iContactId, $this->userId, $defaultGroup);
		}
		
		// добавляем себе в группу
		$arMyContactList = $this->_get_contactList($this->userId);
		if(array_key_exists($iContactId, $arMyContactList['newU'])){
			// если он у нас в игноре
			if($arMyContactList['newU'][$iContactId]['list_id'] == 3) return array('status'=>'ignor', 'toId'=> $iContactId);
		}else{
			$this->addUserToGroup($this->userId, $iContactId, $defaultGroup);
		}
		
		$arFields = array('user_id_to'=>intval($iContactId), 'user_id_from'=>$this->userId, 'message'=>$sMessage);
		$arInsert = $DB->PrepareInsert("itrack_webmessenger_messages", $arFields);
		$strSql = "INSERT INTO itrack_webmessenger_messages (".$arInsert[0].") VALUES (".$arInsert[1].")";
		$DB->Query($strSql, false);
		return array('status'=>'ok', 'toId'=> $iContactId);
	}	
	
	function removeUserFromGroup($iUserId, $iUserIdInList, $iGroupId){
		global $DB;
		$strSql = "DELETE FROM
						itrack_webmessenger_contactlist
					WHERE
						user_id = ".intval($iUserId)." AND
						user_id_list = ".intval($iUserIdInList)." AND
						group_id = ".intval($iGroupId);
		$DB->Query($strSql, false);
	}
	
	function addUserToGroup($iUserId, $iUserIdInList, $iGroupId){
		global $DB;
		$arFields = array('user_id'=>intval($iUserId), 'user_id_list'=>intval($iUserIdInList), 'group_id'=>intval($iGroupId));
		$arInsert = $DB->PrepareInsert("itrack_webmessenger_contactlist", $arFields);
		$strSql = "INSERT INTO itrack_webmessenger_contactlist (".$arInsert[0].") VALUES (".$arInsert[1].")";
		$DB->Query($strSql, false);
	}

	function getMessages($iContactId){

		global $DB;
		$iContactId = intval($iContactId);
		$strSql = '
			SELECT 
				*
			FROM 
				itrack_webmessenger_messages
			WHERE
				(user_id_from = "'.$this->userId.'" AND user_id_to = "'.$iContactId.'" AND readed_user_id_from = "0" AND deleted_user_id_from = "0") OR
				(user_id_from = "'.$iContactId.'" AND user_id_to = "'.$this->userId.'" AND readed_user_id_to = "0" AND deleted_user_id_to = "0")		
		';
		
		$obMessages = $DB->Query($strSql);
		$arResult = array();
		while($arMessage = $obMessages->Fetch()){
			
			$timeMessage = strtotime($arMessage['date_create']);
			if(date("Ymd") == date("Ymd", $timeMessage)){
				$dateMessage = date("H:i:s", $timeMessage);
			}else{
				$dateMessage = date("d.m.Y H:i:s", $timeMessage);
			}
		
			$arResult[] = array(
								'from'	=>	$arMessage['user_id_from'],
								'to'	=>	$arMessage['user_id_to'],
								'text'	=>	nl2br($arMessage['message']),
								'time'	=>	$dateMessage
							);
			
			// ставим в "прочитано" свои же сообщения
			if($arMessage['user_id_from'] == $this->userId){
				$strSql = "UPDATE itrack_webmessenger_messages SET readed_user_id_from = 1 WHERE id = ".$arMessage['id'];
				$DB->Query($strSql, false);
			}
			
			// ставим в "прочитано" сообщения для нас
			if($arMessage['user_id_to'] == $this->userId){
				$strSql = "UPDATE itrack_webmessenger_messages SET readed_user_id_to = 1 WHERE id = ".$arMessage['id'];
				$DB->Query($strSql, false);
			}
			
		}
		return $arResult;
	
	}	
	
	function getHistory($iHistoryWith, $sMonth, $sDay, $sType, $iTimeZone ){
		
		global $DB;
		$iHistoryWith = intval($iHistoryWith);
		
		switch($sType){
			case 'preview':
			
				$strSql = '
					SELECT 
						DATE_FORMAT(date_create,"%Y%m") as datecr
					FROM 
						itrack_webmessenger_messages
					WHERE
						(user_id_from = "'.$this->userId.'" AND user_id_to = "'.$iHistoryWith.'" AND deleted_user_id_from = "0") OR
						(user_id_from = "'.$iHistoryWith.'" AND user_id_to = "'.$this->userId.'" AND deleted_user_id_to = "0")
					GROUP BY datecr 
					ORDER BY datecr DESC
				';
				
				$obMessagesDate = $DB->Query($strSql);
				$arResult = array();
				while($arMessageDate = $obMessagesDate->Fetch()){
					$year = substr($arMessageDate['datecr'], 0, 4);
					$month = substr($arMessageDate['datecr'], 4, 2);
					
					$name = FormatDate("Y f", MakeTimeStamp('01.'.'.'.$month.'.'.$year));
					$arResult[$arMessageDate['datecr']."ym"] = $name;
				}
				
				
				return $arResult;
			break;
			case 'month':
			
				
				$year = substr($sMonth, 0, 4);
				$month = substr($sMonth, 4, 2);
				
				$strSql = '
					SELECT 
						DATE_FORMAT(date_create,"%Y%m%d") as datecr
					FROM 
						itrack_webmessenger_messages
					WHERE
						(
							(user_id_from = "'.$this->userId.'" AND user_id_to = "'.$iHistoryWith.'" AND deleted_user_id_from = "0") OR
							(user_id_from = "'.$iHistoryWith.'" AND user_id_to = "'.$this->userId.'" AND deleted_user_id_to = "0")
						)
						AND
							date_create >= "'.$year.'-'.$month.'-01 00:00:00" AND date_create < "'.$year.'-'.str_pad(($month+1),2,0,STR_PAD_LEFT).'-01 00:00:00"
					GROUP BY datecr ORDER BY datecr DESC
				';
				
				$obMessagesDate = $DB->Query($strSql);
				$arResult = array();
				while($arMessageDate = $obMessagesDate->Fetch()){
				
					$year = substr($arMessageDate['datecr'], 0, 4);
					$month = substr($arMessageDate['datecr'], 4, 2);
					$day = substr($arMessageDate['datecr'], 6, 2);
					$name = date("d.m.Y", MakeTimeStamp($day.'.'.$month.'.'.$year));
					$arResult[$day."d"] = $name;
				}
				return $arResult;
			break;	
			case 'day':
			
				
				$year = substr($sMonth, 0, 4);
				$month = substr($sMonth, 4, 2);
				$strSql = '
					SELECT 
						DATE_FORMAT(date_create,"%H:%i:%s") as datecr,
						user_id_from,
						message
					FROM 
						itrack_webmessenger_messages
					WHERE
						(
							(user_id_from = "'.$this->userId.'" AND user_id_to = "'.$iHistoryWith.'" AND deleted_user_id_from = "0") OR
							(user_id_from = "'.$iHistoryWith.'" AND user_id_to = "'.$this->userId.'" AND deleted_user_id_to = "0")
						)
						AND
							date_create >= "'.$year.'-'.$month.'-'.$sDay.' 00:00:00" AND date_create <= "'.$year.'-'.$month.'-'.$sDay.' 23:59:59"
					ORDER BY datecr ASC
				';
				$obMessagesDate = $DB->Query($strSql);
				$arResult = array();
				while($arMessageDate = $obMessagesDate->Fetch()){
					$arResult[] = array('userId'=>$arMessageDate['user_id_from'], 'time'=>$arMessageDate['datecr'], 'text'=>nl2br($arMessageDate['message']));
				}
				return $arResult;
			break;			
		}

		
	}

	function delHistory($iDeleteWith, $sMonth, $sDay){
		global $DB;
		$year = substr($sMonth, 0, 4);
		$month = substr($sMonth, 4, 2);
		$iDeleteWith = intval($iDeleteWith);
		if(!$iDeleteWith) return;
		// удаляем те, которые отправляли нам
		$strSql = '
			UPDATE
				itrack_webmessenger_messages
			SET 
				deleted_user_id_from = 1 	
			WHERE 
				user_id_from = "'.$this->userId.'" AND
				user_id_to = "'.$iDeleteWith.'" AND
				deleted_user_id_from = "0" AND
				date_create >= "'.$year.'-'.$month.'-'.$sDay.' 00:00:00" AND
				date_create <= "'.$year.'-'.$month.'-'.$sDay.' 23:59:59"
		';
		$DB->Query($strSql);
		$strSql = '
			UPDATE
				itrack_webmessenger_messages
			SET 
				deleted_user_id_to = 1 	
			WHERE 
				user_id_from = "'.$iDeleteWith.'" AND
				user_id_to = "'.$this->userId.'" AND
				deleted_user_id_to = "0" AND
				date_create >= "'.$year.'-'.$month.'-'.$sDay.' 00:00:00" AND
				date_create <= "'.$year.'-'.$month.'-'.$sDay.' 23:59:59"
		';
		$DB->Query($strSql);
	}
	
	
	// получить список идов пользователей от которых нам есть сообщения
	function readMessages($arExIds = array(0)){
		global $DB;
		$strSql = '
			SELECT 
				DISTINCT user_id_from
			FROM 
				itrack_webmessenger_messages
			WHERE
				user_id_to = "'.$this->userId.'" AND readed_user_id_to = "0" AND deleted_user_id_to = "0" AND
				user_id_from NOT IN ('.implode(',',$arExIds).')	
		';
		
		$obMessages = $DB->Query($strSql);
		$arResult = array();
		while($arMessage = $obMessages->Fetch()){
			$arResult[] = intval($arMessage['user_id_from']);
		}
		return $arResult;
	}
	

	
}

?>